clear
%DATOS VARIOS
u=1; % velocidad del viento (norma UNE-EN 12975-2, m/s)
boltzmann=5.67e-08; %Constante de Stefan-Boltzmann
g_t=9.81; %Cte gravedad (m/s^2)
pi=3.1415926;
conc=0 %glicol

Long=[0:0.01:1.83]
casos=length(Long)-1

%DATOS INSTALACIN
A_a=2; %Area del colector
beta=45; % Angulo inclinacin del plano respecto a la horizontal ()
beta_rad=(beta*2*pi)/360;% pasamos el angulo a radianes
N=1; %Numero de vdrios del colector
N_t=9; % Nmero de tubos del panel absorbedor
W=1.105; %Anchura total placa absorbedora (m)
w=W/N_t; %Anchura placa absorbedora por tubo (m)
D_i=0.007; %Diametro interior de los tubos (m)
D_e=0.008;  %Diametro exterior de los tubos (m)
b=0.04; %Espesor captador (m)
delta_abs=0.0005; %Espesor de la placa del absorbedor (m)
delta_aisl=0.025; %Espesor del aislante del captador (m)
delta_tubo=0.0005; %Espesor del tubo (m)
g=0.0035; %Amplitud de la soldadura (m)
L=1.83; %Longitud tuberias%
tau_g=0.95; %Transmitancia de la cubierta transparente
alfa_abs=0.945; %Absortancia del absorbedor
e_g=0.88; %Emitancia cubierta transparente
e_abs=0.05; %Emitancia del absorbedor (vara entre rangos)
g=0.0035; %Ancho zona de contacto entre tubo y aleta (m)

%DATOS T Y CONDUCTIVIDADES TERMICAS
G=850; %Irradiacin solar incidente global (W/m^2)
%T_finn=90+273.15; %T entrada fluido (K)
T_a=20+273.15; %Temperatura ambiente (norma, K) 
%T_abs=75.9+273.15; %Temperatura del absorbedor (K)?????
k_aisl=0.045; %Cond. trmica del aislante (W/mK)
k_abs=209.3; %Conductividad trmica del absorbedor (W/mK)
g_d=6.6; %Conductividad de la soldadura (W/mK) Podemos tocarlo
g_d=3600;
k_tubo=372; %Cte conductividad del tubo (W/mK)

%DATOS FLUJO
q_min=72; %gasto msico minimo total (Kg/h*m^2)
f_masicomin=(q_min*A_a)/N_t/3600; %Flujo msico mnimo por tubo (Kg/s)

%BUCLE PARA EL CLCULO DE PRDIDAS
h_w=5.7+(3.8*u); % Coef. transf. q. debido al viento en la cubierta (W7m^2K)
C=520*(1-0.000051*(beta_rad^2)); %parametro de la ecuacion de perdidas de klein
f=((9/h_w)-(30/h_w^2))*(T_a/316.9)*(1+0.091*N); %Relacin entre la resistencia trmica externa e interna
U_be=k_aisl/delta_aisl; %Coef. perdidas del fondo y laterales del colector


S=G*(tau_g*alfa_abs); %Energa solar absorbida por el colector (W/m^2)

%BUCLE PARAMETROS DE FLUJO

T_finn=[17.5 20 40 55 60 70 80 90]+273.15
k=1
for k=1:size(T_finn,2)
T_fin(k,1)=T_finn(k)
j=2
for i=1:casos
T_abs(1)=30+273.14
T_abs(2)=300
while abs((T_abs(j)-T_abs(j-1)))>0.01    
U_t1(k,i)=(N/((C/T_abs(j))*((T_abs(j)-T_a)/(N+f))^0.252)+(1/h_w))^-1;    
%U_t1(k,i)=((N/(C/T_abs(j)*((T_abs(j)-T_a)/(N+f))^0.252))+(1/h_w))^-1;vie

U_t2(k,i)=boltzmann*(T_abs(j)+T_a)*(T_abs(j)^2+T_a^2);
U_t3(k,i)=(e_abs+(0.0425*N*(1-e_abs)))^-1+(((2*N)+f-1)/e_g)-N;
U_t(k,i)=U_t1(k,i)+(U_t2(k,i)/U_t3(k,i));
U_l(k,i)=U_be+U_t(k,i); %Coef. global de prdidas de calor del captador con T uniforme de absorbedor
    
x(k,i)=Long(i)+(Long(i+1)-Long(i))/2;
A(k,i)=W*(Long(i+1)-Long(i))/9; 

%%%%PROPIEDADES GLICOL
BB(k,i)=71.639163222-0.66981698459*T_fin(k,i)+0.0019150513174*T_fin(k,i)^2-0.0000018587687783*T_fin(k,i)^3;
CC(k,i)=0.27019804611-0.0012299975866*T_fin(k,i)+0.0000015045427918*T_fin(k,i)^2;
mu(k,i)=exp(BB(k,i)+CC(k,i)*conc);% Viscosidad fluido conductor (Pa*s)

DD(k,i)=3.8649883866-0.023691954902*conc-0.00011278222908*conc^2;
EE(k,i)=0.001023655712+0.000056633876714*conc;
c_f(k,i)=(DD(k,i)+EE(k,i)*T_fin(k,i)).*1000;%% Cp fluido conductor (j/kgK) 

FF(k,i)=875.54696219+2.151387542*conc;
GG(k,i)=1.1191046068-0.0007599907262*conc-0.000049236799989*conc^2;
HH(k,i)=-0.002377960199-0.0000091377252136*conc+0.00000010872237562*conc^2;
rof(k,i)=FF(k,i)+GG(k,i)*T_fin(k,i)+HH(k,i)*T_fin(k,i)^2;%Densidad fluido conductor (kg/m^3)

II(k,i)=-0.78595253278+0.015561899561*conc-0.000048933521576*conc^2;
JJ(k,i)=0.0076866167254-0.0001155974176*conc+0.0000003660336083*conc^2;
KK(k,i)=-0.0000099976810237+0.00000014560615474*conc-4.5879383578E-10*conc^2;
k_f(k,i)=II(k,i)+JJ(k,i)*T_fin(k,i)+KK(k,i)*T_fin(k,i)^2; %Cond trmica fluido

%%%%PROPIEDADES AGUA (DENSIDaAD Y CALOR ESP) NORMA UNE
%rof(k,i)=999.85+(6.187e-02*T_fin(k,i))-(7.654e-03*T_fin(k,i)^2)+(3.974e-05*T_fin(k,i)^3)-(1.11e-07*T_fin(k,i)^4);
%c_f(k,i)=1000*(4.217-3.358e-03*T_fin(k,i)+1.089e-04*T_fin(k,i)^2-1.675e-06*T_fin(k,i)^3+1.309e-08*T_fin(k,i)^4-3.884e-11*T_fin(k,i)^5);

%%%%PROPIEDADES AGUA AGUSTIN
%mu(k,i)=0.0000001*T_fin(k,i)^2-0.00003*T_fin(k,i)+0.0015;
%c_f(k,i)=0.0099*T_fin(k,i)^2-0.8087*T_fin(k,i)+4197;
%k_f(k,i)=-0.000008*T_fin(k,i)^2+0.0019*T_fin(k,i)+0.5641;
%rof(k,i)=-0.0033*T_fin(k,i)^2-0.1063*T_fin(k,i)+1001.6;



Pr(k,i)=(mu(k,i)*c_f(k,i))/k_f(k,i); %N Prandtl
Re(k,i)=(4*f_masicomin)/(pi*D_i*mu(k,i)); %Valor N Reynolds para caudal mnimo establecido
Gz(k,i)=(pi/4)*(x(k,i)/(D_i*Re(k,i)*Pr(k,i)))^-1; %Valores N Graetz dependern de la posicin x del fluido en el tubo
Nu_lam(k,i)=4.36*(1+(Gz(k,i)/29.6)^2)^(1/6)*(1+((Gz(k,i)/19.04)/((1+(Pr(k,i)/0.0207)^(2/3))^(1/2)*(1+(Gz(k,i)/29.6)^2)^(2/3)))^(3/2)); %Valor N Nusselt establecido 
F_PED(k,i)=0.25*(1.82*LOG10(Re(k,i))-1.64)^-2;
Nu_tur(k,i)=(Re(k,i)-1000)*Pr(k,i)*F_PED(k,i)/2/(1.07+12.7.*(Pr(k,i)^(2/3)-1)*(F_PED(k,i)/2)^0.5);

if Re(k,i)<2300
    Nu(k,i)=Nu_lam(k,i);
else
    Nu(k,i)=Nu_lam(k,i)*((4000-Re(k,i))/1700)+Nu_tur(k,i)*((Re(k,i)-2300)/1700);
end


%Nu(k,i)=500*(4.36*(1+(Gz(k,i)/29.6)^2)^(1/6)*(1+((Gz(k,i)/19.04)/((1+(Pr(k,i)/0.0207)^(2/3))^(1/2)*(1+(Gz(k,i)/29.6)^2)^(2/3)))^(3/2))); %Valor N Nusselt establecido 
h_fi(k,i)=Nu(k,i)*k_f(k,i)/D_i; %Coeficiente de transferencia de calor del fluido para qmin (W/m 2K)

%BUCLE EXPRESIONES EISENMANN
mu_d(k,i)=1/2*((pi*D_i)-g)*sqrt((Nu(k,i)*k_f(k,i))/(D_i*k_tubo*delta_tubo)); %Parametro tipo Biot
nu_d(k,i)=tanh(mu_d(k,i))/mu_d(k,i); %Eficiencia de aleta del tubo
s_inf(k,i)=((pi*nu_d(k,i))/2)+(((1+nu_d(k,i))*g)/(2*D_i)); %Factor de forma
c_e(k,i)=(g_d*g)/(2*k_f(k,i)*Nu(k,i)); %Parmetro de conductancia en el contacto entre aleta y tubo
k_gf(k,i)=(1/c_e(k,i)+1/s_inf(k,i))^-1*((2*k_f(k,i)*Nu(k,i))/(pi*D_i)); %Coef. transm. q entre fluido y zona de contacto (W/m 2K)

%CALCULOS F, F' Y F_r
m(k,i)=sqrt(U_l(k,i)/(k_abs*delta_abs)); %Parametro para el calculo de F
%F(k,i)=(tanh(m(k,i)*(w-D_e)/2))/(m(k,i)*(w-D_e)/2); %Hobbi
F(k,i)=(tanh((m(k,i)/2)*(w-g)))/((m(k,i)/2)*(w-g)); %Eisenmann
F_primae(k,i)=(w*((1/((w-g)*F(k,i)+g))+(U_l(k,i)/(k_gf(k,i)*pi*D_i))))^-1; %Eisenmann
F_primah(k,i)=(1/U_l(k,i))/(w*(1/(U_l(k,i)*(D_e+(w-D_e)*F(k,i)))+(1/g_d)+1/(pi*D_i*h_fi(k,i)))); %Hobbi

%F_r(k,i)=((f_masicomin*c_f(k,i))/(A(k,i)*U_l(k,i)))*(1-exp(-(F_primah(k,i)*U_l(k,i)*A(k,i))/(f_masicomin*c_f(k,i)))); Hobbi %Al calcular Factor remocin, para ambas expr (F_r, F_rmax) emplea F' para qmin y por la expresin de Hobbi
F_r(k,i)=((f_masicomin*c_f(k,i))/(A(k,i)*U_l(k,i)))*(1-exp(-(F_primae(k,i)*U_l(k,i)*A(k,i))/(f_masicomin*c_f(k,i)))); %Eisenmann %Al calcular Factor remocin, para ambas expr (F_r, F_rmax) emplea F' para qmin y por la expresin de Hobbi



%OBTENCIN RENDIMIENTO, TEMPERATURAS, ETC

Q_util(k,i)=A(k,i)*F_r(k,i)*(S-(U_l(k,i)*(T_fin(k,i)-T_a)));
T_abs_cal(k,i)=T_fin(k,i)+(Q_util(k,i)/(A(k,i)*U_l(k,i)*F_r(k,i)))*(1-F_r(k,i)); %Temperatura absoluta del absorbedor para qmin (K)
T_fout(k,i)=T_fin(k,i)+(Q_util(k,i)/(f_masicomin*c_f(k,i))); %Temperatura de salida qmin
 
j=j+1
T_abs(j)=T_abs_cal(k,i);
end

j=2
%T_abs(k,i)=T_abs_cal(k,i)
T_fin(k,i+1)=T_fout(k,i);
end
end


for k=1:size(T_finn,2)
eficiencia(k)=sum(Q_util(k,:))/(W*L/9*G); %Eficiencia de colector con caudal mnimo establecido
T_out(k)=T_fout(k,casos);
T_absorbedor(k)=mean(T_abs_cal(k));
t_m(k)=(T_finn(k)+T_fout(k,casos))/2; %Temperatura mkzedia del fluido de transferenciad de calor (K)
T_m(k)=(t_m(k)-T_a)/G; %(Tm*) Tadimensionel Diferencia de T absoluta reducida (m^2K/W)
EFI_SOL_1(k)=0.787-4.653.*T_m(k);
EFI_SOL_2(k)=0.799-3.4.*T_m(k)-0.026.*G.*T_m(k)^2;
end

DATOS=[T_finn' T_out' T_absorbedor' T_m' eficiencia' EFI_SOL_1' EFI_SOL_2']

P=polyfit(DATOS(:,4),DATOS(:,5),1)
A=polyfit(DATOS(:,4),DATOS(:,5),2)

EFI_CAL_1=P(2)+P(1).*DATOS(:,4);
EFI_CAL_2=A(3)+A(2).*DATOS(:,4)+(A(1)/G).*DATOS(:,4).^2;

%figure(1)
%plot(T_m,eficiencia,'ko',T_m,EFI_SOL_1,'k-',T_m,EFI_SOL_2,'b-')

%figure(2)
%plot(T_m,eficiencia,'ko',T_m,EFI_CAL_1,'r-',T_m,EFI_CAL_2,'g-')


